package class8_2_FactoryMethodPattern_start;// Dr. Yoder. MSOE. 15 December 2016

import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class ShapeManager {
    private List<Shape> shapes = new ArrayList<Shape>();
    private List<ShapeFactory> shapeFactories = new ArrayList<>();

    public void addShapeFactory(ShapeFactory factory) {
        shapeFactories.add(factory);
    }

    public void run() {
        int input;
        input = getInput(shapes);
        while(input != 0) {
            Shape newShape = null;
            // TODO: Use factory method pattern
            // to make this code closed for modification
            // but open for extension.
            if(input == 1) {
                newShape = new Circle();
            } else if(input == 2) {
                newShape = new Triangle();
            } else if(input == 3) {
                newShape = new Rectangle();
            }
            if(newShape != null) {
                shapes.add(newShape);
            } else {
                System.err.println("Warning: Could not add shape. Unknown command: "+input);
            }
            displayShapes();
            input = getInput(shapes);
        }
    }

    private void displayShapes() {
        System.out.println("Current shapes: ");
        for(Shape shape:shapes) {
            System.out.println(" "+shape);
        }
        System.out.println();
    }

    private int getInput(List<Shape> shapes) {
        // TODO: Use factory method pattern
        // to make this code closed for modification
        // but open for extension.
        System.out.println("Please enter an option:");
        System.out.println(" 1 - Create Circle");
        System.out.println(" 2 - Create Triangle");
        System.out.println(" 3 - Create Rectangle");
        System.out.println(" 0 - Exit program");
        Scanner in = new Scanner(System.in);
        return in.nextInt();
    }

    public void add(Shape shape) {
        shapes.add(shape);
    }
}
